package se.softstuff.nb.bundleeditor.editor;

import java.awt.Component;
import java.awt.event.MouseEvent;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Enumeration;
import java.util.List;
import java.util.ResourceBundle;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import org.openide.DialogDescriptor;
import org.openide.DialogDisplayer;
import org.openide.NotifyDescriptor;
import org.openide.util.Lookup;
import org.openide.util.editable.EditableResourceBundle;
import org.openide.util.editable.NbBundle;
import org.openide.util.editable.NbResourceBundler;
import se.softstuff.nb.bundleeditor.EditableBundler;
import se.softstuff.nb.bundleeditor.search.SearchElement;
import se.softstuff.nb.bundleeditor.search.SearchElementResultRow;
import se.softstuff.nb.domain.NbBundleDiff;
import se.softstuff.nb.domain.swing.ColumnRenderer;
import se.softstuff.nb.domain.tracer.HighlightedComponent;
import se.softstuff.nb.domain.swing.GlassUtil;
import se.softstuff.nb.domain.tracer.MarkerUtilities;

/**
 *
 * @author stefan
 */
public class ComponentEditorPanel extends javax.swing.JPanel implements ListSelectionListener {

    public static void edit(MouseEvent mouseEvent, NbBundleDiff translation){
        
        GlassUtil glassUtil = Lookup.getDefault().lookup(GlassUtil.class);
        
        Component component = glassUtil.findComponentUnderGlassPaneAt(mouseEvent);
        
        NbResourceBundler bundler = NbBundle.getBundler();
        if( !(bundler instanceof EditableBundler)){
            return;
        }
        
        EditableBundler editableBundler = (EditableBundler)bundler;
        
        ComponentEditorPanel editor = new ComponentEditorPanel(component, translation, editableBundler);
                
        
        DialogDescriptor nd = new DialogDescriptor(
                editor, // instance of your panel
                "Title" // title of the dialog
                );
        
        DialogDisplayer.getDefault().notify(nd);
                
    }
    
    /**
     * Creates new form ComponentEditorPanel
     */
    public ComponentEditorPanel(Component componentToTranslate, NbBundleDiff translation, EditableBundler editableBundler) {
        this();
        initResultTableColumns();
        initLanguageTableColumns();
        
        model.init(componentToTranslate, translation, editableBundler);
        
        String text = model.findComponentText(componentToTranslate);        
        String componentName = componentToTranslate.getName();

        nameSearchTextField.setText(componentName);
        textSearchTextField.setText(text);
        
        this.resultTable.getSelectionModel().addListSelectionListener(this);
        
        search();
        
    }
    
    public ComponentEditorPanel() {
        initComponents();
    }
    
    
    public final void search(){
        String nameSearch = nameSearchTextField.getText();
        String textSearch = textSearchTextField.getText();
        
        List<SearchElementResultRow> rows = model.search(nameSearch, textSearch);
        
        tableModel.setRows(rows);
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        model = new se.softstuff.nb.bundleeditor.editor.ComponentEditorPresentationModel();
        tableModel = new se.softstuff.nb.domain.swing.DynamicTableModel<SearchElementResultRow>();
        languageTableModel = new se.softstuff.nb.domain.swing.DynamicTableModel();
        jScrollPane1 = new javax.swing.JScrollPane();
        resultTable = new javax.swing.JTable();
        jPanel2 = new javax.swing.JPanel();
        nameSearchTextField = new javax.swing.JTextField();
        jLabel1 = new javax.swing.JLabel();
        textSearchTextField = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        searchButton = new javax.swing.JButton();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();

        setName("Form"); // NOI18N

        jScrollPane1.setName("jScrollPane1"); // NOI18N

        resultTable.setModel(tableModel);
        resultTable.setName("resultTable"); // NOI18N
        jScrollPane1.setViewportView(resultTable);

        jPanel2.setName("jPanel2"); // NOI18N

        nameSearchTextField.setName("nameSearchTextField"); // NOI18N
        nameSearchTextField.setNextFocusableComponent(searchButton);
        nameSearchTextField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                nameSearchTextFieldActionPerformed(evt);
            }
        });

        org.openide.awt.Mnemonics.setLocalizedText(jLabel1, org.openide.util.NbBundle.getMessage(ComponentEditorPanel.class, "ComponentEditorPanel.jLabel1.text")); // NOI18N
        jLabel1.setName("jLabel1"); // NOI18N

        textSearchTextField.setName("textSearchTextField"); // NOI18N
        textSearchTextField.setNextFocusableComponent(searchButton);
        textSearchTextField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                textSearchTextFieldActionPerformed(evt);
            }
        });

        org.openide.awt.Mnemonics.setLocalizedText(jLabel3, org.openide.util.NbBundle.getMessage(ComponentEditorPanel.class, "ComponentEditorPanel.jLabel3.text")); // NOI18N
        jLabel3.setName("jLabel3"); // NOI18N

        org.openide.awt.Mnemonics.setLocalizedText(searchButton, org.openide.util.NbBundle.getMessage(ComponentEditorPanel.class, "ComponentEditorPanel.searchButton.text")); // NOI18N
        searchButton.setName("searchButton"); // NOI18N
        searchButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                searchButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 97, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel3, javax.swing.GroupLayout.PREFERRED_SIZE, 97, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(nameSearchTextField)
                    .addComponent(textSearchTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 246, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addComponent(searchButton)
                .addGap(130, 130, 130))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(searchButton)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel3)
                            .addComponent(textSearchTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel1)
                            .addComponent(nameSearchTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jScrollPane2.setName("jScrollPane2"); // NOI18N

        jTable1.setModel(languageTableModel);
        jTable1.setName("jTable1"); // NOI18N
        jScrollPane2.setViewportView(jTable1);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, 460, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(0, 0, Short.MAX_VALUE))
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 927, Short.MAX_VALUE)
                    .addComponent(jScrollPane1))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 154, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 114, javax.swing.GroupLayout.PREFERRED_SIZE))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void searchButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_searchButtonActionPerformed
       search();        
    }//GEN-LAST:event_searchButtonActionPerformed

    private void textSearchTextFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_textSearchTextFieldActionPerformed
        search();
    }//GEN-LAST:event_textSearchTextFieldActionPerformed

    private void nameSearchTextFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_nameSearchTextFieldActionPerformed
        search();
    }//GEN-LAST:event_nameSearchTextFieldActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JTable jTable1;
    private se.softstuff.nb.domain.swing.DynamicTableModel languageTableModel;
    private se.softstuff.nb.bundleeditor.editor.ComponentEditorPresentationModel model;
    private javax.swing.JTextField nameSearchTextField;
    private javax.swing.JTable resultTable;
    private javax.swing.JButton searchButton;
    private se.softstuff.nb.domain.swing.DynamicTableModel tableModel;
    private javax.swing.JTextField textSearchTextField;
    // End of variables declaration//GEN-END:variables

    private void initResultTableColumns() {
        ColumnRenderer keyColumn = new ColumnRenderer<SearchElementResultRow, String>() {

            @Override
            public String headerText() {
                return NbBundle.getMessage(ComponentEditorPanel.class, "ComponentEditorPanel.key.column.header");
            }

            @Override
            public String render(SearchElementResultRow row) {
                return row.getKey();
            }

        };
        ColumnRenderer originalColumn = new ColumnRenderer<SearchElementResultRow, String>() {
            @Override
            public String headerText() {
                return NbBundle.getMessage(ComponentEditorPanel.class, "ComponentEditorPanel.original.column.header");
            }

            @Override
            public String render(SearchElementResultRow row) {
                return row.getOriginal();
            }
        };
        ColumnRenderer valueColumn = new ColumnRenderer<SearchElementResultRow, String>() {
            @Override
            public String headerText() {
                return NbBundle.getMessage(ComponentEditorPanel.class, "ComponentEditorPanel.value.column.header");
            }

            @Override
            public String render(SearchElementResultRow row) {
                return row.getValue();
            }

            @Override
            public boolean isCellEditable(SearchElementResultRow row) {
                return true;
            }

            @Override
            public void setValueAt(SearchElementResultRow row, String newValue) {
                model.editRow(row, newValue);
                super.setValueAt(row, newValue);
            }            
        };

        ColumnRenderer langColumn = new ColumnRenderer<SearchElementResultRow, String>() {
            @Override
            public String headerText() {
                return NbBundle.getMessage(ComponentEditorPanel.class, "ComponentEditorPanel.language.column.header");
            }

            @Override
            public String render(SearchElementResultRow row) {
                return row.getLanguage();
            }
        };
        ColumnRenderer moduleColumn = new ColumnRenderer<SearchElementResultRow, String>() {
            @Override
            public String headerText() {
                return NbBundle.getMessage(ComponentEditorPanel.class, "ComponentEditorPanel.module.column.header");
            }

            @Override
            public String render(SearchElementResultRow row) {
                return row.getModule();
            }
        };

        ColumnRenderer resouceColumn = new ColumnRenderer<SearchElementResultRow, String>() {
            @Override
            public String headerText() {
                return NbBundle.getMessage(ComponentEditorPanel.class, "ComponentEditorPanel.resouce.column.header");
            }

            @Override
            public String render(SearchElementResultRow row) {
                return row.getResource();
            }
        };

        this.tableModel.addColumn(originalColumn, valueColumn, langColumn, keyColumn, moduleColumn, resouceColumn);
        
    }
    
    private void initLanguageTableColumns() {
        
        ColumnRenderer valueColumn = new ColumnRenderer<LanguageRowModel, String>() {
            @Override
            public String headerText() {
                return NbBundle.getMessage(ComponentEditorPanel.class, "ComponentEditorPanel.LanguageRowModel.value.column.header");
            }

            @Override
            public String render(LanguageRowModel row) {
                return row.getNewValue();
            }

            @Override
            public boolean isCellEditable(LanguageRowModel row) {
                return true;
            }

            @Override
            public void setValueAt(LanguageRowModel row, String newValue) {
                model.editLanguageRow(row, newValue);
                super.setValueAt(row, newValue);
            }            
        };
        
        
        languageTableModel.addColumn(LanguageRowModel.createLanguageColumn(), LanguageRowModel.createStandardValueColumn(), valueColumn, LanguageRowModel.createKeyColumn(), LanguageRowModel.createResourceColumn(), LanguageRowModel.createModuleColumn());
    }

    @Override
    public void valueChanged(ListSelectionEvent e) {
        int selectedRow = resultTable.getSelectedRow();
       SearchElementResultRow row = (SearchElementResultRow)tableModel.getRow(selectedRow);
       if(row == null){
           languageTableModel.clear();
       } else {
            Collection<LanguageRowModel> rows = model.findLanguageRowsFor(row);
           languageTableModel.setRows(rows);
       }
    }

    

}
